﻿using System.ComponentModel;
using System.IO;
using Buddy.Common.Xml;
using Buddy.XmlEngine;

namespace WingIt
{
    public class WingItSettings : XmlSettings
    {
        public WingItSettings()
            : base(Path.Combine(Path.Combine(SettingsDirectory, "WingIt"), "WingItSettings.xml"))
        {
        }

        private static WingItSettings _inst;
        public static WingItSettings Instance { get { return _inst ?? (_inst = new WingItSettings()); } }

        [XmlElement("CombatOnly")]
        [DefaultValue(false)]
        public bool CombatOnly { get; set; }
    }
}
